## org.apache.commons.collections
Interface OrderedMap

All Superinterfaces:
  IterableMap, java.util.Map

All Known Subinterfaces:
  OrderedBidiMap, SortedBidiMap

All Known Implementing Classes:
  AbstractLinkedMap, AbstractOrderedBidiMapDecorator, AbstractOrderedMapDecorator, AbstractSortedBidiMapDecorator, DualTreeBidiMap, LinkedMap, ListOrderedMap, LRUMap, SingletonMap, TreeBidiMap, UnmodifiableOrderedBidiMap, UnmodifiableOrderedMap, UnmodifiableSortedBidiMap

    public interface OrderedMap

extends IterableMap

Defines a map that maintains order and allows both forward and backward iteration through that order.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne

Nested Class Summary

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Method Summary
`java.lang.Object` `firstKey()` Gets the first key currently in this map.
`java.lang.Object` `lastKey()` Gets the last key currently in this map.
`java.lang.Object` `nextKey(java.lang.Object key)` Gets the next key after the one specified.
`OrderedMapIterator` `orderedMapIterator()` Obtains an `OrderedMapIterator` over the map.
`java.lang.Object` `previousKey(java.lang.Object key)` Gets the previous key before the one specified.

Methods inherited from interface org.apache.commons.collections.IterableMap
`mapIterator`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Method Detail

### orderedMapIterator

    OrderedMapIterator orderedMapIterator()

  Obtains an `OrderedMapIterator` over the map.

  A ordered map iterator is an efficient way of iterating over maps in both directions.

       BidiMap map = new TreeBidiMap();
       MapIterator it = map.mapIterator();
       while (it.hasNext()) {
         Object key = it.next();
         Object value = it.getValue();
         it.setValue("newValue");
         Object previousKey = it.previous();
       }

  Returns:
    a map iterator

### firstKey

    java.lang.Object firstKey()

  Gets the first key currently in this map.

  Returns:
    the first key currently in this map
  Throws:
    `java.util.NoSuchElementException` - if this map is empty

### lastKey

    java.lang.Object lastKey()

  Gets the last key currently in this map.

  Returns:
    the last key currently in this map
  Throws:
    `java.util.NoSuchElementException` - if this map is empty

### nextKey

    java.lang.Object nextKey(java.lang.Object key)

  Gets the next key after the one specified.

  Parameters:
    `key` - the key to search for next from
  Returns:
    the next key, null if no match or at end

### previousKey

    java.lang.Object previousKey(java.lang.Object key)

  Gets the previous key before the one specified.

  Parameters:
    `key` - the key to search for previous from
  Returns:
    the previous key, null if no match or at start

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.